<template>
    <nav class="navigation main_navigation">
        <ul class="navigation__list-link" ref="listLink" id="listLink" @click="getActiveSection">
            <li class="navigation__line"></li>
            <li
                class="navigation__link"
                :class="(curentSection == 'third_section') ? 'active' : ''"
            >
                <a href="#third_section">{{ local.joining[$lang] }}</a>
            </li>
            <li class="navigation__dot"></li>
            <li
                class="navigation__link"
                :class="(curentSection == 'fourth_section') ? 'active' : ''"
            >
                <a href="#fourth_section">{{ local.benefits[$lang] }}</a>
            </li>
            <li class="navigation__dot"></li>
            <li
                class="navigation__link"
                :class="(curentSection == 'fifth_section') ? 'active' : ''"
            >
                <a href="#fifth_section">{{ local.functionality[$lang] }}</a>
            </li>
            <li class="navigation__dot"></li>

            <li
                class="navigation__link"
                :class="(curentSection == 'sixth_section') ? 'active' : ''"
            >
                <a href="#sixth_section">{{ local.programs[$lang] }}</a>
            </li>
            <li class="navigation__dot"></li>
            <li
                class="navigation__link"
                :class="(curentSection == 'seventh_section') ? 'active' : ''"
            >
                <a href="#seventh_section">{{ local.rates[$lang] }}</a>
            </li>
            <li class="navigation__dot"></li>
            <li
                class="navigation__link"
                :class="(curentSection == 'eighth_section') ? 'active' : ''"
            >
                <a href="#eighth_section">{{ local.feedback[$lang] }}</a>
            </li>
            <li class="navigation__line"></li>
        </ul>
    </nav>
</template>

<script>
import local from '../localisation/nav.js';

export default {
    mounted() {
        const isIE11 = '-ms-scroll-limit' in document.documentElement.style && '-ms-ime-align' in document.documentElement.style;
        const colorMain = 'white';
        const colorMore = 'green';
        const colorActive = 'black';
        const navigationSection = document.getElementsByClassName('navigation__list-link')[0];
        const navigationLinksIe = document.querySelectorAll("#listLink > li > a")
        const firstSection = document.getElementById('first_section'); // темная

        const thirdSection = document.getElementById('third_section'); //подключение
        const fourthSection = document.getElementById('fourth_section'); //преимущества
        const fifthSection = document.getElementById('fifth_section'); // темная функционал
        const sixthSection = document.getElementById('sixth_section'); // программы
        const seventhSection = document.getElementById('seventh_section'); // тарифы
        const eighthSection = document.getElementById('eighth_section'); // темная отзывы

        this.arrSectionMenu = [thirdSection, fourthSection, fifthSection, sixthSection, seventhSection, eighthSection]; // массив меню секций
        const arrSection = [firstSection, fifthSection, eighthSection]; // массив темных секций
        const self = this
        let heightWindow = window.innerHeight;
        if (heightWindow % 2) heightWindow++;

        handlerOnscroll();

        function setGradientTop(dot) {
            navigationSection.style.background = isIE11? 'transparent': `linear-gradient(to right, ${colorMain} ${dot}px, ${colorMore}  ${dot}px, ${colorMore}  ${heightWindow}px)`;
            navigationSection.style.webkitBackgroundClip = 'text';
            navigationSection.style.mozBackgroundClip = 'text';
            // link_5.style.background = `linear-gradient(to right, ${colorMain} ${dot}px, ${colorMore}  ${dot}px, ${colorMore}  ${heightWindow}px, ${colorMain} ${heightWindow}px)`;
            // link_5.style.webkitBackgroundClip = 'text';
            // link_5.style.mozBackgroundClip = 'text';
        }
        function setGradientBottom(dot) {
            navigationSection.style.background =  isIE11? 'transparent': `linear-gradient(to right, ${colorMore} ${dot}px, ${colorMain}  ${dot}px, ${colorMain}  ${heightWindow}px)`;
            navigationSection.style.webkitBackgroundClip = 'text';
            navigationSection.style.mozBackgroundClip = 'text';
        }

        window.addEventListener('resize', () => {
            heightWindow = window.innerHeight;
            handlerOnscroll();
        });
        window.addEventListener('scroll', handlerOnscroll);
        window.addEventListener('scroll', this.getActiveSection);

        function handlerOnscroll() {
            let dot = 0;
            if (window.innerHeight % 2 === 1) window.listLink.style.width = 'calc(100vh - 1px)';
            else window.listLink.style.width = '100vh';

            for (let i = 0; i < arrSection.length; i++) {
                const element = arrSection[i];
                const heightSection = element.offsetHeight;
                const coordinatesSection = element.getBoundingClientRect();

                const yTop = coordinatesSection.top;
                const yBottom = coordinatesSection.top + heightSection;
                //ie block
                if(isIE11){  
                    for (let i=0; i<navigationLinksIe.length; i++){

                        let linkBottom = navigationLinksIe[i].getBoundingClientRect().bottom - 50
                        if(yTop > 0 && yBottom >0 && linkBottom < yBottom && linkBottom<yTop ){
                            navigationLinksIe[i].style.color = colorMore
                        }
                        if(yTop > 0 && yBottom >0 && linkBottom > yTop && linkBottom< yBottom){
                            navigationLinksIe[i].style.color = colorMain
                        }
                        if(yTop <= 0 && yBottom >0 && linkBottom < yBottom ){
                            navigationLinksIe[i].style.color = colorMain
                        }
                        if(yTop <= 0 && yBottom >0 && linkBottom > yBottom ){
                            navigationLinksIe[i].style.color = colorMore
                        }
                    }
                } 
                //ie block end
        
                if (yTop < heightWindow && yTop >= 0) {
                    dot = heightWindow - yTop;
                    setGradientTop(dot);
                    break;
                } else if (yBottom < heightWindow && yBottom >= 0) {
                    dot = heightWindow - yBottom;
                    setGradientBottom(dot);
                    break;
                } else if (yTop < 0 && yBottom > heightWindow) {
                    navigationSection.style.background =  isIE11? 'transparent': colorMain;
                    navigationSection.style.webkitBackgroundClip = 'text';
                    navigationSection.style.mozBackgroundClip = 'text';
                    break;
                } else if ((yTop > heightWindow || yTop < 0) && (yBottom > heightWindow || yBottom < 0)) {
                    navigationSection.style.background =  isIE11? 'transparent': colorMore;
                    navigationSection.style.webkitBackgroundClip = 'text';
                    navigationSection.style.mozBackgroundClip = 'text';
                }
            }
        }
    },
    data() {
        return {
            arrSectionMenu: '', // массив меню секций
            curentSection: ' ',
            local,
        };
    },
    methods: {
        getActiveSection() {
            this.arrSectionMenu.forEach(element => {
                const yTop = element.getBoundingClientRect().top;
                const breakpoint = window.innerHeight * 0.49;
                if ((breakpoint > yTop && yTop >= 0) || (-breakpoint < yTop && yTop <= 0)) {
                    this.curentSection = element.id;
                }
            });
        },
    },
};
</script>

<style lang="scss" scoped>
.active {
    a {
   
        background: linear-gradient(to right, #dedc00, #dedc00);
        -webkit-background-clip: text;
    }
    @media screen and (-ms-high-contrast: active), (-ms-high-contrast: none)  {
        a {
            background: transparent;
            color: rgba(189, 186, 0, 1) !important;
        }
    }
}
.wrapper {
    .content {
        max-width: 1680px;
        justify-content: center;
        width: 100%;
    }
}
.navigation {
    &__list-link {
        -webkit-background-clip: text;
        height: 50px;
        list-style-type: none;
        text-transform: uppercase;
        width: 100vh;
        padding: 0 50px;
        margin: 0;
        display: flex;
        justify-content: space-between;
        // height: 100px;
        transform-origin: 50% 0;
        transform: rotate(-90deg);
        position: fixed;
        top: 50vh;
        left: calc(-50vh + 65px);
        align-items: center;
        z-index: 100;
        @media (max-width: 1400px) {
            left: calc(-50vh + 10px);
        }
        @media (max-width: 900px) {
            display: none;
        }
    }
    &__link {
        margin-left: 5px;
        margin-right: 5px;

        a {
            text-decoration: none;
            -webkit-text-fill-color: transparent;
            &:active {
                //   -webkit-text-fill-color: rgb(0, 0, 0);
            }
            &:visited {
                //    -webkit-text-fill-color:lightgray;
            }
        }
    }
    &__dot {
        width: 3px;
        height: 3px;
        border-radius: 50%;
        background-color: #dedc00;
        flex-shrink: 1;
    }
    &__line {
        margin-left: 5px;
        margin-right: 5px;
        width: 100px;
        height: 2px;
        background-color: #dedc00;
        // background-color:transparent;
        flex-shrink: 1;
    }
    .active_nav_link {
        /*color: #95c11f;*/
    }
}
</style>
